/****************************************************************************/
/*                                                                          */
/*    Routines.c   Version 1.0    By Craig Derouen                          */
/*                 A Maximus CBBCS Timebank program                         */
/*                                                                          */
/*                                                                          */
/****************************************************************************/


#include "maxtime.h"
#include "globals.h"

struct user_cfg USCFG;
int EmptyRecs;

int addtime(void)
{
   unsigned int x,z;
   unsigned long calc;

   x = LastUser.timeremaining - timeon();	/* How much time left to give? */

   if ((x + USERCFG.dailydep) > MaxDepoDaily) {		/* Adjust */
      x = MaxDepoDaily - USERCFG.dailydep;
   }
   if (x <= 2) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\n\r\nSorry but you don't have enough time left to save.\r\n");
      return FALSE;
   }

   z = MaxBankSession < x ? MaxBankSession : x;
   sprintf(temp,"\r\n\r\nYou may store up to %u minutes in the timebank today.\r\n\r\n",z);
   strout(temp);
   x = gettime(z);		/* Fetch amount */
   if (x) {
      calc = 0xffffffff - USERCFG.banktime;		/* Calculate ceiling */
      if (calc < 0xffff) {
         x = x < (unsigned) calc ? x : (unsigned) calc;
      }
   		   /* Okay everything's set */
      if (x > 0) {
         sprintf(temp,"User has added %u minutes to bank",x);
         logit(temp,'#');
      }
      USERCFG.banktime += x;
      USERCFG.dailydep += x;
      MinutesWanted = ((int) (x)) * -1;		/* We are subtracting */
      USERCFG.deposits++;
      return TRUE;
   }
   else return FALSE;
}

int withdrawtime(void)
{
   unsigned int x;
   int tremain,z;
   unsigned long btime;

   btime = (unsigned long) MaxTimeSession <= USERCFG.banktime ? (unsigned long) MaxTimeSession : USERCFG.banktime;
   tremain = LastUser.timeremaining - timeon();


   if(btime && MaxTimeDaily && USERCFG.dailywtd) {
      if (USERCFG.dailywtd >= MaxTimeDaily) {
         setcolor(TextAttr[ATTN_TEXT]);
         strout("\r\n\r\nSorry but you have already withdrawn all your available time today.\r\n");
         return FALSE;
      }
      btime = (unsigned long)  btime > (MaxTimeDaily - USERCFG.dailywtd) ? (unsigned long) (MaxTimeDaily - USERCFG.dailywtd) : btime;
   }

   if (!btime) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\n\r\nSorry but you don't have any time available to withdraw.\r\n");
      return FALSE;
   }

   sprintf(temp,"\r\n\r\nYou have %lu minutes stored in the timebank currently.\r\n",USERCFG.banktime);
   strout(temp);

   x = BBStime + timeon() + (unsigned int) btime; 	/* Total maximum time */

/* Now compute btime against Maximum possible time on bbs, pending events upcoming */

   if ((unsigned long) (x) <= Rstart->max_time) { /* We can bump it up */
      z = (int) ((Rstart->max_time - (unsigned long) tremain) < btime ? (Rstart->max_time - (unsigned long) tremain) : btime);
      if (z > 0)
         sprintf(temp,"You may borrow up to %d minutes from timebank today.\r\n",z);
   }
   else {		/* Will bump event, fudge it to max that we can do */
      z = (int) (Rstart->max_time - (unsigned long) (tremain + timeon()));
      if(z > 0)
         sprintf(temp,"An event is coming up. You may only borrow %d minutes the timebank today.\r\n\r\n",z);
   }
   if (z > 0)  {
      strout(temp);
      x = gettime((unsigned int) z);		/* Fetch amount */
      if (x > 0) {
         sprintf(temp,"User has subtracted %u minutes from bank",x);
         logit(temp,'#');
         USERCFG.banktime -= x;
         USERCFG.dailywtd += x;
         MinutesWanted = (int) x;
         USERCFG.withdraws++;
         return TRUE;
      }
   }
   else {
      strout("Sorry but no time is available for borrowing right now.\r\n\r\n");
      return FALSE;
   }
}

void Sys_menu(void)
{
   int x,choice;
   char resp;

   choice = TRUE;

   while (choice) {
      setcolor(TextAttr[STD_TEXT]);
      if (SysopMode)
         strout("\r\n\r\nLocal Sysop menu. Select a choice.\r\n");
      else strout("\r\n\r\nSysop menu. Select a choice.\r\n");
      strout("----------------------------\r\n");
      setcolor(TextAttr[MENU_KEY]);
      strout("[A]dd time to user's bank  [C]reate new user\r\n");
      strout("[D]elete a user            [K]ill old users\r\n");
      strout("[L]ist users               [R]emove user's time\r\n");
      if (SysopMode)
         strout("[P]ack user records        [Q]uit\r\n\r\n");
      else strout("[Q]uit\r\n\r\n");
      if (!SysopMode)
         timeremain();
      setcolor(TextAttr[PROMPT_TEXT]);
      strout("Choice --> ");
      x = chrin();
      resp = (char) toupper(x);
      chrout(resp);
      strout("\r\n");
      switch (resp) {
         case 'A':		/* Add user time */
            AddUserTime();
            break;

         case 'C':		/* Create a new user */
            CreateUser();
            break;

         case 'D':		/* Delete single users */
            delete_users();
            break;

         case 'K':		/* Kill older users */
            setcolor(TextAttr[PROMPT_TEXT]);
            strout("\r\nThis will delete all MaxTime users who are no longer active on your bbs\r\n");
            strout("Are you sure you want this? (y,N) ---> ");
            x = chrin();
            resp = (char) toupper(x);
            chrout(resp);
            strout("\r\n");
            if (resp == 'Y') 
               kill_oldusers();
            break;

         case 'L':		/* User stats */
            user_stats();
            break;

         case 'P':
            if (SysopMode)
               PackUsers();
            break;

         case 'Q':		/* Quit */
            choice = FALSE;
            break;

         case 'R':		/* Remove user's time */
            RemoveUserTime();
            break;
      }
   }
   strout("\r\n\r\n");
   setcolor(TextAttr[STD_TEXT]);
}

/* Fetch # of minutes from user, accept values from 0 up to max
   input value. Return value */
unsigned gettime(unsigned max)
{
   char *p;
   int x;

   setcolor(TextAttr[STD_TEXT]);
   strout("\r\n");
   timeremain();
   setcolor(TextAttr[PROMPT_TEXT]);
   sprintf(temp,"Minutes desired (0 to %u) --> ",max);
   strout(temp);
   strin(temp1);
   if (!IsLocal)
      strout("\r\n");
   p = strtok(temp1," \t\r");
   x = atoi(p);
   while ((unsigned) x > max || x < 0) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nSorry but value is out of range!\r\n");
      timeremain();
      setcolor(TextAttr[PROMPT_TEXT]);
      strout(temp);
      strin(temp1);
      if (!IsLocal)
         strout("\r\n");
      p = strtok(temp1," \t\r");
      x = atoi(p);
   }
   return((unsigned) x);
}


void PackUsers(void)
{
   int handl1,handl2,y;
   int old,new;
   char drive[_MAX_DRIVE];
   char dir[_MAX_DIR];
   char fname[_MAX_FNAME];
   char tname[_MAX_PATH];

   handl1 = sopen(CfgFile,O_RDWR | O_BINARY,SH_DENYRW,S_IREAD);
   if (handl1 == -1) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nCan't open user file");
      aborterror(FILEOPEN,"Error opening User config file");
   }

   _splitpath(CfgFile,drive,dir,fname,temp);
   sprintf(tname,"%s%s%s.$$$",drive,dir,fname);

   handl2 = sopen(tname,O_CREAT | O_RDWR | O_BINARY,SH_DENYWR,S_IWRITE);
   if (handl2 == -1) {
      close(handl1);
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nCan't open temp file");
      aborterror(FILEOPEN,"Error opening temp User config file");
   }

   strout("\r\n");
   old = new = 0;
   y = read(handl1,(char *) &USCFG,sizeof(struct user_cfg));
   while (y == sizeof(struct user_cfg)) {
      old++;
      if (USCFG.name[0] && USCFG.isused) { /* Write only the current ones */
         write(handl2,(char *) &USCFG,sizeof(struct user_cfg));
         new++;
         strout("*");
      }
      else strout(".");
      y = read(handl1,(char *) &USCFG,sizeof(struct user_cfg));
   }
   close(handl1);
   close(handl2);
   strout("\r\n");
   if (new != old) {
      setcolor(TextAttr[HILITE_TEXT]);
      sprintf(temp1,"%d empty records of %d total records were deleted.\r\n",old - new,old);
      strout(temp1);
      if(!unlink(CfgFile)) {		/* Remove old file */
         rename(tname,CfgFile); 	/* Rename new file */
      }
   }
   else unlink(tname);		/* Delete temp file then */
}


void kill_oldusers(void)
{
   int handl1,handl2;
   int x,y;
   long pos;
   struct user_cfg uscfg;

   x = FALSE;

   if (UserBBS[0] == 0) {
      while (!x) {
         setcolor(TextAttr[PROMPT_TEXT]);
         strout("Enter complete file\\pathname for User.bbs file\r\n");
         strout("Or type QUIT to exit: ");
         strin(temp);
         if (strcmpi(temp,"Quit") == 0)
            return;
         if (!IsLocal)
            strout("\r\n");
         if(stat(temp,&fbuf) == 0 ) {		/* File does exist */
            strcpy(UserBBS,temp);
            x = TRUE;
         }
         else {
            setcolor(TextAttr[ATTN_TEXT]);
            strout("Sorry but that filename does not exist!\r\n");
         }
      }
   }
   if (test_task()) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nSorry, but someone else is using MaxTime currently. Try later!\r\n");
      return;
   }

   handl1 = sopen(CfgFile,O_RDWR | O_BINARY,SH_DENYWR,S_IWRITE);
   if (handl1 == -1) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nCan't write to user file");
      aborterror(FILEOPEN,"Error opening User config file");
   }

   handl2 = sopen(UserBBS,O_RDWR | O_BINARY,SH_DENYNO,S_IREAD);
   if (handl2 == -1) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nCan't open User.bbs file\r\n");
      close(handl1);
      return;
   }
   y = read(handl1,(char *) &uscfg,sizeof(struct user_cfg));
   x = 0;
   setcolor(TextAttr[STD_TEXT]);
   while (y == sizeof(struct user_cfg)) {
      if (uscfg.isused) {
         if (!find_realuser(uscfg.name,handl2)) {
            strout("*");		/* A little diddle counter */
            uscfg.isused = 0;
            uscfg.name[0] = 0;		/* Null out name */
            pos = tell(handl1) - (long) sizeof(struct user_cfg);	/* Get position */
            lseek(handl1,pos,SEEK_SET); 	/* Rewind back to this record */
            write(handl1,(struct user_cfg *) &uscfg,sizeof(struct user_cfg));
            x++;
         }
         else strout(".");		/* A little diddle counter */
      }
      y = read(handl1,(char *) &uscfg,sizeof(struct user_cfg));
   }
   close(handl1);
   close(handl2);
   if (x) {
      setcolor(TextAttr[HILITE_TEXT]);
      sprintf(temp,"\r\nYou have deleted %d users from config file.\r\n",x);
      strout(temp);
      sprintf(temp,"A sysop has deleted %d users from config file",x);
      logit(temp,'#');
      Countusers();
   }
   else {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nNo users are inactive at this time.\r\n");
   }
   setcolor(TextAttr[STD_TEXT]);
}

void user_stats(void)
{

   int x,row,handle,y;
   struct tm  *newtime;
   char *month;
   char *day;

   setcolor(TextAttr[STD_TEXT]);
   if (!UserCount) 
      Countusers();
   handle = sopen(CfgFile,O_RDWR | O_BINARY,SH_DENYNO,S_IREAD);
   if (handle == -1) {
      strout("\r\nError opening config file! Try later.\r\n");
      return;
   }
   sprintf(temp,"\r\nCurrently, there are %d active users for MaxTime.\r\n",UserCount);
   setcolor(TextAttr[HILITE_TEXT]);
   strout(temp);
   if (EmptyRecs) {
      sprintf(temp,"There are %d empty records in the user file. Use the Pack function to clean.\r\n",EmptyRecs);
      strout(temp);
   }

/* Read all the users and display pertinent data */

   while (1) {
      y = read(handle,(char *) &USCFG,sizeof(struct user_cfg));
      setcolor(TextAttr[STD_TEXT]);
      strout("_________________________________________________________________________\r\n");
      strout("User Name                            Lasttime  Calls     Time   Dep Wdraw\r\n");
      strout("-------------------------------------------------------------------------\r\n");
      row = 3;
      setcolor(TextAttr[HILITE_TEXT]);
      while (row < 23 && y == sizeof(struct user_cfg)) {
         while (!USCFG.isused && y == sizeof(struct user_cfg)) {
            y = read(handle,(char *) &USCFG,sizeof(struct user_cfg));
         }
         if (y != sizeof(struct user_cfg)) 
            break;
         strcpy(temp,USCFG.name);
         while (strlen(temp) < 37)
            strcat(temp," ");
         strout(temp);
         newtime = localtime(&USCFG.lasttime);
         strcpy(temp1,asctime(newtime));
         strtok(temp1," ");               /* Strip Day of week */
         month = strtok(NULL," ");
         day = strtok(NULL," ");
         if (USCFG.calls < 0)
            USCFG.calls = 0;
         sprintf(temp,"%s %s    %5d %8lu %5d %5d\r\n",month,day,USCFG.calls,USCFG.banktime,USCFG.deposits,USCFG.withdraws);
         strout(temp);
         row++;
         y = read(handle,(char *) &USCFG,sizeof(struct user_cfg));
      }
      if (y == sizeof(struct user_cfg)) {		/* Still more records */
         strout("\r\nPress ESC to stop or any other key for more");
         x = chrin();
         strout("\r\n");
         if (x == 0x1b) 
            break;
      }
      else break;
   }
   close(handle);
}

delete_users(void)
{
   int x,User;
   char *p1;

   if (test_task()) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nSorry, but someone else is using MaxTime currently. Try later!\r\n");
   }
   setcolor(TextAttr[STD_TEXT]);
   strout("Enter user's name ---> ");
   strin(temp);
   if (!IsLocal)
      strout("\r\n");
   p1 = strtok(temp,"\t\r\n");
   if (p1) {
      if (strcmpi(p1,LastUser.name) == 0) {
         setcolor(TextAttr[ATTN_TEXT]);
         strout("Whoah there pardner! You can't delete yourself!\r\n");
         return FALSE;
      }
      x = sopen(CfgFile,O_RDWR | O_BINARY | O_CREAT,SH_DENYNO,S_IWRITE);
      if (x == -1)
         aborterror(FILEOPEN,"Error opening/creating User config file");
      User = find_config(x,p1,&USCFG);
      if (User < 0) {
         setcolor(TextAttr[ATTN_TEXT]);
         strout("Sorry but that user name does not exist.\r\n");
      }
      else {
         strout("User is now being deleted.\r\n");
         sprintf(temp1,"Sysop is deleting user: %s",p1);
         logit(temp1,'#');
         USCFG.isused = 0;
         memset(USCFG.name,0,36);		/* Delete */
         lseek(x,(long) User * sizeof(struct user_cfg),SEEK_SET);
         write(x,(struct user_cfg *) &USCFG,sizeof(struct user_cfg));
      }
      close(x);
      Countusers();
   }
   return(TRUE);
}

int test_task(void)
{
   struct find_t c_file;
   int x;

   sprintf(temp,"MxTmAct.%03d",Task);		/* Create a task id */
   unlink(temp);		/* Delete our own task file */

   if (_dos_findfirst("MxTmAct.*",_A_NORMAL,&c_file) == 0) { /* Uh oh. Someone else is using MaxMail! */
      x = sopen(temp,O_RDWR | O_BINARY | O_CREAT,SH_DENYWR,S_IWRITE);
      close(x);		/* Re-Create task file */
      return(TRUE);
   }
   x = sopen(temp,O_RDWR | O_BINARY | O_CREAT,SH_DENYWR,S_IWRITE);
   close(x);		/* Re-Create task file */
   return(FALSE);
}

void AddUserTime(void)
{
   int x,User;
   unsigned y;
   char *p1;

   setcolor(TextAttr[STD_TEXT]);
   strout("Enter user's name ---> ");
   strin(temp);
   if (!IsLocal)
      strout("\r\n");
   p1 = strtok(temp,"\t\r\n");
   if (p1) {
      x = sopen(CfgFile,O_RDWR | O_BINARY,SH_DENYNO,S_IWRITE);
      if (x == -1)
         aborterror(FILEOPEN,"Error opening/creating User config file");
      if((User = find_config(x,p1,&USCFG)) < 0) {
         setcolor(TextAttr[ATTN_TEXT]);
         strout("Sorry but that user name does not exist.\r\n");
      }
      else {
         setcolor(TextAttr[HILITE_TEXT]);
         sprintf(temp,"%s has %lu minutes in bank\r\n",USCFG.name,USCFG.banktime);
         strout(temp);
         strout("You may add up to 65000 minutes to user's record.\r\n");
         y = 65000;
         y = gettime(y);
         if (y) {
            setcolor(TextAttr[STD_TEXT]);
            strout("User time is now being adjusted.\r\n");
            USCFG.banktime += (unsigned long) y;
            sprintf(temp,"Sysop adding %u minutes to %s's record",y,USCFG.name);
            logit(temp,'#');
            lseek(x,(long) (User * sizeof(struct user_cfg)),SEEK_SET);
            write(x,(struct user_cfg *) &USCFG,sizeof(struct user_cfg));
         }
      }
      close(x);
   }
}

void RemoveUserTime(void)
{
   int x,User;
   unsigned y;
   char *p1;

   setcolor(TextAttr[STD_TEXT]);
   strout("Enter user's name ---> ");
   strin(temp);
   if (!IsLocal)
      strout("\r\n");
   p1 = strtok(temp,"\t\r\n");
   if (p1) {
      x = sopen(CfgFile,O_RDWR | O_BINARY,SH_DENYNO,S_IWRITE);
      if (x == -1)
         aborterror(FILEOPEN,"Error opening/creating User config file");
      if((User = find_config(x,p1,&USCFG)) < 0) {
         setcolor(TextAttr[ATTN_TEXT]);
         strout("Sorry but that user name does not exist.\r\n");
      }
      else {
         setcolor(TextAttr[HILITE_TEXT]);
         sprintf(temp,"%s has %lu minutes in bank\r\n",USCFG.name,USCFG.banktime);
         strout(temp);
         y = (unsigned int) USCFG.banktime;
         sprintf(temp,"You may remove up to %u minutes from user's record.\r\n",y);
         strout(temp);
         y = gettime(y);
         if (y) {
            setcolor(TextAttr[STD_TEXT]);
            strout("User time is now being adjusted.\r\n");
            USCFG.banktime -= (unsigned long) y;
            sprintf(temp,"Sysop removing %u minutes from %s's record",y,USCFG.name);
            logit(temp,'#');
            lseek(x,(long) (User * sizeof(struct user_cfg)),SEEK_SET);
            write(x,(struct user_cfg *) &USCFG,sizeof(struct user_cfg));
         }
      }
      close(x);
   }
}

void Countusers(void)
{
   int handle,y;

   UserCount = 0;
   EmptyRecs = 0;
   handle = sopen(CfgFile,O_RDWR | O_BINARY,SH_DENYNO,S_IREAD);
   if (handle == -1) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nError opening config file! Try later.\r\n");
      return;
   }
   y = read(handle,(char *) &USCFG,sizeof(struct user_cfg));
   while (y == sizeof(struct user_cfg)) {
      if (USCFG.name[0])
         UserCount++;
      else EmptyRecs++;
      y = read(handle,(char *) &USCFG,sizeof(struct user_cfg));
   }
   close(handle);
}

void CreateUser(void)
{
   int handl1,handl2;
   int x;

   x = FALSE;
   if (UserBBS[0] == 0) {
      while (!x) {
         setcolor(TextAttr[PROMPT_TEXT]);
         strout("Enter complete file\\pathname for User.bbs file\r\n");
         strout("Or type QUIT to exit: ");
         strin(temp);
         if (strcmpi(temp,"Quit") == 0)
            return;
         if (!IsLocal)
            strout("\r\n");
         if(stat(temp,&fbuf) == 0 ) {		/* File does exist */
            strcpy(UserBBS,temp);
            x = TRUE;
         }
         else {
            setcolor(TextAttr[ATTN_TEXT]);
            strout("Sorry but that filename does not exist!\r\n");
         }
      }
   }
   if (test_task()) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nSorry, but someone else is using MaxTime currently. Try later!\r\n");
      return;
   }
   
   handl1 = sopen(CfgFile,O_RDWR | O_BINARY,SH_DENYWR,S_IWRITE);
   if (handl1 == -1) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nCan't write to user file");
      aborterror(FILEOPEN,"Error opening User config file");
   }

   handl2 = sopen(UserBBS,O_RDWR | O_BINARY,SH_DENYNO,S_IREAD);
   if (handl2 == -1) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nCan't open User.bbs file\r\n");
      close(handl1);
   }
   setcolor(TextAttr[PROMPT_TEXT]);
   strout("\r\nEnter user name: ");
   strin(temp1);
   if (!IsLocal)
      strout("\r\n");

   if (find_config(handl1,temp1,&USCFG) >= 0) { /* Test to see if its already there */
      close(handl1);
      close(handl2);
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nThat name already exists in the Maxtime records.\r\n");
      return;
   }
   if (!find_realuser(temp1,handl2)) {
      close(handl1);
      close(handl2);
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nThat name does not exist in your Maximus user records.\r\n");
      return;
   }
   close(handl2);		/* We don't need user.bbs anymore */

   setcolor(TextAttr[HILITE_TEXT]);
   strout("\r\nAdding new user to Maxtime records.\r\n");
   sprintf(temp,"Sysop is adding new user: %s",temp1);
   logit(temp,'#');
   memset(&USCFG,0,sizeof(struct user_cfg));
   strcpy(USCFG.name,temp1);
   USCFG.isused = TRUE;

   if((x = find_blconfig(handl1)) < 0) 	/* Look for an empty slot */
      x = new_user(handl1);		/* We will append a new record */

/* Fix up some fields in the new record */

   time(&USCFG.lasttime);
   USCFG.lasttime -= (time_t)(86400);		/* Subtract 24 hours */
   USCFG.calls = 0;
   lseek(handl1,(long) (x * sizeof(struct user_cfg)),SEEK_SET);/* Append to tail of file */
   write(handl1,(struct user_cfg *) &USCFG,sizeof(struct user_cfg));
   close(handl1);
   Countusers();		/* We just added a new one */
}
